--  

GConf = {}

GConf.mode_index = 1
GConf.modes = {}
GConf.res_text = 0
GConf.x = 0
GConf.y = 0
GConf.height = 0
GConf.width = 0
GConf.windowed = true
GConf.gconf = 0
GConf.volume = 0
GConf.win = 0
GConf.name = "GConf"
GConf.text_window = 0
GConf.text_fullscreen = 0

function GConf.create()
local _gconf = {}
setmetatable(_gconf, {__index = GConf})
_gconf.text_window = glang:get('Windowed')
_gconf.text_fullscreen = glang:get('Fullscreen')
return _gconf
end
--[[TODO:   love.graphics.toggleFullscreen
  : love.graphics.getModes / love.graphics.checkMode
 : love.graphics.setMode
width, height, fullscreen, vsync, fsaa = love.graphics.getMode( )
 ,    ,  /,  
   -   ,  .     
     
]] 
function GConf:findResolution(w,h)
	for i=1,#self.modes do
		if w == self.modes[i].width and h == self.modes[i].height then
			self.mode_index = i
			return
		end
	end
end
function GConf:getResText()
	return (self.modes[self.mode_index].width.."x"..self.modes[self.mode_index].height)
end
function GConf:getWinText()
	if self.windowed then
		return self.text_window
	else
		return self.text_fullscreen
	end
end
function GConf:addToSceneManager(man_objs)
	s_width, s_height, s_fullscreen, s_vsync, s_fsaa = love.graphics.getMode()
	self.modes = love.graphics.getModes()
	self.windowed = not s_fullscreen	
	table.sort(self.modes, function(a, b) return a.width*a.height < b.width*b.height end)
	self:findResolution(s_width, s_height)	
	self.res_text = GObject.create("text")
	self.res_text.x = Configuration.inst().screen_width/2-100
   	self.res_text.y = Configuration.inst().screen_height/3
   	self.res_text.value = self:getResText()
   	self.res_text.width = 200
   	self.res_text.height = love.graphics.getFont():getHeight()
   	self.res_text.text_align = "center"
   	self.res_text.render_rect=true
   	self.res_text.color = GSkins.window_title_text
   	self.res_text.rect_color = GSkins.window_title_text   	
   	self.res_text.draw_cor_x = 5
   	self.res_text.name = self.name..".".."res_text"
    
    self.win_text = deepcopy(self.res_text)
	self.win_text.y = self.res_text.y+40
	self.win_text.value = self:getWinText()
	--self.win_text.left_button_click = GConf.toggle_windowed
	self.win_text.name = self.name..".".."win_text"	
   	
   	local left_button = GObject.create("draw") 		
	left_button.x = self.res_text.x - 30
	left_button.y = self.res_text.y
	left_button.left_button_click = GConf.res_btn_left
	left_button.width = 25
	left_button.height = 25 
	left_button:loadButton("left")
	left_button.gconf = self
	left_button.name = self.name..".".."left_button"		
	
	local right_button = GObject.create("draw") 		
	right_button.x = self.res_text.x + self.res_text.width+5
	right_button.y = self.res_text.y
	right_button.left_button_click = GConf.res_btn_right
	right_button.width = 25
	right_button.height = 25 
	right_button:loadButton("right")
	right_button.gconf = self	
	right_button.name = self.name..".".."right_button"		
	
	local left_button2 = deepcopy(left_button)
	left_button2.y = left_button.y+40
	left_button2.left_button_click = GConf.toggle_windowed
	left_button2.gconf = self
	left_button2.name = self.name..".".."left_button2"	
	
	local right_button2 = deepcopy(right_button)
	right_button2.y = left_button2.y
	right_button2.left_button_click = GConf.toggle_windowed
	right_button2.gconf = self
	right_button2.name = self.name..".".."right_button2"
   	
   	local win = GWindow.create('OK_CANSEL')
   	win.ok_event = GConf.save
   	win.cansel_event=GConf.cansel
   	win:takeMySize(self)   	
   	win.name = "options"
   	win.caption = glang:get('Options')
   	win:addToSceneManager(man_objs)
   	win.ok_button.gconf = self   	
   	win.cansel_button.gconf = self
   	win.close_button.gconf = self
   	
   	local volume = GVolume.create()
   	volume.x=left_button.x+left_button.width+5
   	volume.width=self.res_text.width
   	volume.height=self.res_text.height
   	volume.y=right_button2.y+volume.height*2
   	volume.post_str="%"
   	volume.prefix_str = glang:get('Volume ')
   	volume.maxvalue=100
   	volume.value = love.audio.getVolume()*100   
   	volume.on_change_value = GConf.set_volume
   	volume.on_init = GConf.on_init_snd
   	volume.gconf = self
   	volume.name = self.name..".".."volume"
   	local volume_arr = volume:addToSceneManager(man_objs)
   	
   	local lang_label = GObject.create("text")
	lang_label.x = self.x
   	lang_label.y = volume.y + volume.height*2
   	lang_label.value = glang:get("Language")
   	lang_label.width = self.width
   	lang_label.height = love.graphics.getFont():getHeight()
   	lang_label.text_align = "center"
   	lang_label.color = GSkins.window_title_text
   	--lang_label.draw_cor_x = 5
   	lang_label.name = self.name..".".."lang_label"
   	
   	local rus_flag = GObject.create("draw")
   	rus_flag:loadButton('rus_flag')
   	--rus_flag.width = 84
   	--rus_flag.height = 84
   	rus_flag.x = (self.x+self.width)/2 - rus_flag.width/2
   	rus_flag.y = lang_label.y + rus_flag.height
   	rus_flag.left_button_click = GConf.change_lang_rus
   	rus_flag.name = self.name..".".."rus_flag"
   	
   	local us_flag = GObject.create("draw")
   	us_flag:loadButton('us_flag')
   	--us_flag.width = 84
   	--us_flag.height = 84
   	us_flag.x = (self.x+self.width)/2 + us_flag.width
   	us_flag.y = rus_flag.y
   	us_flag.left_button_click = GConf.change_lang_eng
   	us_flag.name = self.name..".".."us_flag"
   	
   	table.insert(man_objs, self.res_text)
   	table.insert(man_objs, self.win_text)
   	table.insert(man_objs, left_button)
   	table.insert(man_objs, right_button)
   	table.insert(man_objs, left_button2)
   	table.insert(man_objs, right_button2)
   	table.insert(man_objs, lang_label)
   	table.insert(man_objs, rus_flag)
   	table.insert(man_objs, us_flag)
   	
   	win:addToWin(self.res_text)
   	win:addToWin(self.win_text)
   	win:addToWin(left_button)
   	win:addToWin(right_button)
   	win:addToWin(left_button2)
   	win:addToWin(right_button2)
   	win:addToWin(volume)
   	win:addToWinArray(volume_arr)
   	win:addToWin(lang_label)
   	win:addToWin(rus_flag)
   	win:addToWin(us_flag)
   	
   	winman:add(win)
end

function GConf.change_lang_rus(obj)
	glang.cur_lang = 2
end

function GConf.change_lang_eng(obj)
	glang.cur_lang = 1
end

function GConf.set_volume(obj, value)	
	obj.gconf.volume = value
end

function GConf.on_init_snd(obj)
	obj.gconf.volume = math.ceil(love.audio.getVolume()*100)
	obj.value = obj.gconf.volume		
	obj_rt = Configuration.inst().manager:findByName('GConf.volume.slider','options')
	if obj_rt~=nil then
		obj_rt.bx=-100
		GVolume.slider_set_pos(obj_rt)
	end
end

function GConf.res_btn_left(obj)
	if obj.gconf.mode_index>1 then
		obj.gconf.mode_index=obj.gconf.mode_index-1
		obj.gconf.res_text.value = obj.gconf:getResText()
	end
end

function GConf.res_btn_right(obj)
	if obj.gconf.mode_index < #obj.gconf.modes then
		obj.gconf.mode_index=obj.gconf.mode_index+1
		obj.gconf.res_text.value = obj.gconf:getResText()
	end
end

function GConf.toggle_windowed(obj)
	obj.gconf.windowed = (not obj.gconf.windowed)	
	obj.gconf.win_text.value = obj.gconf:getWinText()
end

function GConf.save(obj)
	love.audio.setVolume(obj.gconf.volume/100)
	if Configuration.inst().screen_width ~= obj.gconf.modes[obj.gconf.mode_index].width or 
	Configuration.inst().screen_height ~= obj.gconf.modes[obj.gconf.mode_index].height or
	Configuration.inst().screen_windowed ~= obj.gconf.windowed then
		Configuration.inst().screen_width = obj.gconf.modes[obj.gconf.mode_index].width
    	Configuration.inst().screen_height = obj.gconf.modes[obj.gconf.mode_index].height
    	Configuration.inst().screen_windowed = obj.gconf.windowed
		love.graphics.setMode( Configuration.inst().screen_width, Configuration.inst().screen_height, (not Configuration.inst().screen_windowed))
		love.graphics.setFont(love.graphics.newFont("PTN57F.ttf", transformSize(20)))
		load_gui()
		--[[if( not Configuration.inst().screen_windowed ) then
			local exit_button = Configuration.inst().manager:findByName('exit_button')
			if exit_button ~= nil then
				exit_button.visible = 1
			end
		end	]]	
	end
	obj.gconf:saveToFile()
end

function GConf.cansel(obj)
	glang.cur_lang = obj.gconf.lang
end

function GConf:load(obj)
	s_width, s_height, s_fullscreen, s_vsync, s_fsaa = love.graphics.getMode()
	self.windowed = not s_fullscreen
	self:findResolution(s_width, s_height)	
   	self.res_text.value = self:getResText()
   	self.win_text.value = self:getWinText()
   	self.lang = glang.cur_lang
end

function GConf:saveToFile()
    s_width, s_height, s_fullscreen, s_vsync, s_fsaa = love.graphics.getMode()
	local node = require("xmlSimple").newNode('options')
	local sound = require("xmlSimple").newNode('sound')
	local graph = require("xmlSimple").newNode('graph')
	local game = require("xmlSimple").newNode('game')	
	sound:addProperty('volume',math.ceil(love.audio.getVolume()*100)/100)
	graph:addProperty('fullscreen', tostring(s_fullscreen))
	graph:addProperty('width', s_width)
	graph:addProperty('height', s_height)
	game:addProperty('lang', glang.cur_lang)
	node:addChild(graph)
	node:addChild(sound)
	node:addChild(game)
	local xmlstr = createXML(node, true)
	love.filesystem.write( 'options.xml', xmlstr, string.len(xmlstr) )
end

function GConf.findResolutionInArray(modes, width)
	local hires = nil
	for i=1,#modes do
		if modes[i]==width then
			hires = modes[i]
		end
	end
end

function GConf.loadFromFile(pname)
local screen_width = 1024
local screen_height = 768

local fullscreen = false
local sound_volume = 1
local xml = require("xmlSimple").newParser()
local dir = love.filesystem.getAppdataDirectory()
local cur_lang = 1
--dir = string.gsub(dir,'src',pname)
dir = dir..'/LOVE/'..pname
local xml_file = xml:loadFile("options.xml", dir)
if xml_file~= nil then
	screen_width = tonumber(xml_file.options.graph['@width'])
	screen_height = tonumber(xml_file.options.graph['@height'])	
	fullscreen = (xml_file.options.graph['@fullscreen']=='true')
	sound_volume = tonumber(xml_file.options.sound['@volume'])
	cur_lang = tonumber(xml_file.options.game['@lang'])
end
 Configuration.inst().cur_lang = cur_lang
 Configuration.inst().first_launch = (xml_file==nil)
return screen_width, screen_height, fullscreen, sound_volume
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

function createXML(root, isroot)
	if isroot==nil then
		isroot = true
	end
	local str = '' 
	if isroot then
		str = '<?xml version="1.0" encoding="UTF-8"?>\n'
	end
	str=str..'<'..root:name()
	local props = root:properties()
	for p=1,root:numProperties() do
		local pvalue = (root[('@'..props[p].name)])
		str=str..' '..props[p].name..'='..'\''..pvalue..'\''--props[p].value
	end
	if root:numChildren() == 0 then
		str=str..'/>'
		return str
	end
	str=str..'>'
	local childs = root:children()
	for i=1,root:numChildren() do
		str=str..createXML(childs[i], false)
	end
	str=str..'</'..root:name()..'>'
	return str
end