GHorLayout = {}

GHorLayout.objs = {}
GHorLayout.x = 0
GHorLayout.y = 0
GHorLayout.width = 0
GHorLayout.height = 0

function GHorLayout.create(x, y)
	local _ghorlaytout = {}	
	setmetatable(_ghorlaytout, {__index = GHorLayout})
	_ghorlaytout.objs = {}
	_ghorlaytout.x = x
	_ghorlaytout.y = y
	return _ghorlaytout
end


function GHorLayout:add(obj)	
	if #self.objs == 0 then
		obj.x = self.x
		obj.y = self.y
	else
		local last = self.objs[#self.objs]
		obj.x = last.x+last.width+last.width/4
		obj.y = self.y
	end
	table.insert(self.objs, obj)	
end

function GHorLayout:replace()
	for i=1,#self.objs do
		if i == 1 then
			self.objs[i].x = self.x
			self.objs[i].y = self.y
		else
			local last = self.objs[(i-1)]
			self.objs[i].x = last.x+last.width+last.width/4
			self.objs[i].y = self.y
		end
	end
end

--    
function GHorLayout:centerByX(cx)
	local gen_width = self.objs[#self.objs].x+self.objs[#self.objs].width - self.x
	self.x = cx - gen_width/2
	self:replace()
end

function GHorLayout:addToSceneManager(man_objs)
	for i=1,#self.objs do
		table.insert(man_objs, self.objs[i])
	end
end