--  

GList = {}
--GList.items = {}
GList.x = 0
GList.y = 0
GList.height = 0
GList.width = 0
GList.x_margin = 10
GList.y_margin = 10
GList.item_height = 20
GList.item_space = 0
GList.click_sound = 0
GList.color = 0
GList.rect_color = 0
GList.name = 'GList'
GList.first_item = 0
GList.last_item = 0

function GList.create()
local _glist = {}
setmetatable(_glist, {__index = GList})
_glist.name = name
_glist.items = {}
_glist.gitems = {}
return _glist
end

function GList:Add(item)
	table.insert(self.items, item)
end

function GList:addToSceneManager(man_objs)
	for i=1,#self.items do	
		local obj = GObject.create("text")
		obj.name = i
		obj.x = self.x+self.x_margin
   		obj.y = self.y+self.y_margin+(i-1)*(self.item_height + self.item_space)
   		local item_value = self.items[i]
   		--[[if type(self.items[i])=='table' then
   			item_value = self.items[i]:get()
   		end]]
   		obj.value = item_value
   		obj.width = self.width
   		obj.height = self.item_height
   		obj.text_align = "left"
   		obj.mouse_enter = GObject.selectRect
   		obj.mouse_leave = GObject.unselectRect
   		obj.draw_cor_x = 5
   		obj.draw_cor_y = 5
   		obj.left_button_click = choose_cur_track
   		obj.click_sound = self.click_sound
   		obj.color = self.color
   		obj.rect_color = self.rect_color
   		obj.scroll_up = GList.scroll_up
   		obj.when_stop = GList.stop_scroll
   		--obj:setSelectedRect() render_rect=true 
   		table.insert(man_objs, obj)
   		table.insert(self.gitems, obj)
   		if( i== 1) then
   			self.first_item = obj
   		end
   		
   		if( i== #self.items) then
   			self.last_item = obj
   		end
   		
   		for s=1,5 do
   		   local star = GObject.create("draw")
		   star:loadAnimation("star_",3, 1)   
		   star.x = obj.x+obj.width - obj.width/4+s*star.width
		   star.y = obj.y
		   star.index = 2
		   star.on_show = updateStar
		   star.scroll_up = GList.scroll_up
		   star.when_stop = GList.stop_scroll
		   table.insert(man_objs, star)
		   table.insert(self.gitems, star)
		   star.row = i
		   star.col = s
   		end   				
	end
	--   
	local list_top_scroll_panel = GObject.create('obj')
	list_top_scroll_panel.value="line"
	list_top_scroll_panel.color = {255, 0, 0, 255}
	list_top_scroll_panel.x = self.x+self.x_margin
	list_top_scroll_panel.width = self.width
	list_top_scroll_panel.y = self.y
	list_top_scroll_panel.height = self.item_height*2
	list_top_scroll_panel.mouse_enter = GList.list_bottom_scroll_panel_enter
	list_top_scroll_panel.mouse_leave = GList.list_scroll_panel_leave
	list_top_scroll_panel.moved = false
	list_top_scroll_panel:setParentAndName(self, 'list_top_scroll_panel')
	
	local list_bottom_scroll_panel = GObject.create('obj')
	list_bottom_scroll_panel.value="line"
	list_bottom_scroll_panel.color = {0, 255, 0, 255}
	list_bottom_scroll_panel.x = self.x+self.x_margin
	list_bottom_scroll_panel.width = self.width
	if self.height>0 then
		list_bottom_scroll_panel.y = self.y+self.height-self.item_height*2
	else
		list_bottom_scroll_panel.y = Configuration.inst().screen_height-self.item_height*2
	end
	list_bottom_scroll_panel.height = self.item_height*2
	list_bottom_scroll_panel.mouse_enter = GList.list_top_scroll_panel_enter
	list_bottom_scroll_panel.mouse_leave = GList.list_scroll_panel_leave
	list_bottom_scroll_panel.moved = false
	list_bottom_scroll_panel:setParentAndName(self, 'list_bottom_scroll_panel')
	
	table.insert(man_objs, list_bottom_scroll_panel)
	table.insert(man_objs, list_top_scroll_panel) 
end

function GList:addToScroll(obj)
	table.insert(self.gitems, obj)
end

function updateStar(obj)
	local value = Configuration.inst().songs_rate[obj.row]
	local val = 2
	if value >= (obj.col*20-10) then
		val = 3
	end
	if value >= (obj.col*20) then
		val = 1
	end
	obj.index = val
end

function GList.list_top_scroll_panel_enter(obj)
	local bot_line = obj.parent.last_item.y+obj.parent.last_item.height	
	if (not obj.moved) and (bot_line>Configuration.inst().screen_height) then
		GList.set_scroll(obj.parent, obj.parent.item_height*(-2), obj)
		obj.moved = true
	end
end

function GList.list_scroll_panel_leave(obj)
	if obj.moved then
		GList.set_scroll(obj.parent, 0)
		obj.moved = false
	end
end

function GList.list_bottom_scroll_panel_enter(obj)
	local top_line = obj.parent.first_item.y	
	if (not obj.moved) and (top_line<obj.parent.y) then
		GList.set_scroll(obj.parent, obj.parent.item_height*2, obj)
		obj.moved = true
	end
end


function GList.set_scroll(list, speed, line)
	local items = list.gitems
	for i=1,#items do
		items[i].line = line		
		items[i].scroll_up(items[i], speed)
	end
end

function GList.scroll_up(obj, speed)
	obj.speed_y = speed
end

function GList.stop_scroll(obj, sx, sy)
	if sy>0 then
		local top_line = obj.line.parent.first_item.y	
		if top_line>obj.line.parent.y+obj.height/3 then
			return true
		end
	end
	if sy<0 then
		local bot_line = obj.line.parent.last_item.y+obj.line.parent.last_item.height	
		if bot_line<=Configuration.inst().screen_height-obj.height/3 then
			return true
		end
	end
	return false
end