GSceneManager = {}

GSceneManager.scenes = {}
GSceneManager.active_scene = 0
GSceneManager.last_scene = 0
GSceneManager.cur_add_scene = 0
GSceneManager.back_scene = 0

function GSceneManager.create()
local _gscenemanager = {}
setmetatable(_gscenemanager, {__index = GSceneManager})
return _gscenemanager
end

function GSceneManager:render()
	if self.active_scene == 0 then
		return
	end	
	if self.back_scene ~= 0 then
		GObject.renderArray(self.scenes[self.back_scene].objs)	
		GObject.renderRectArray(self.scenes[self.back_scene].objs)
	end
	GObject.renderArray(self.scenes[self.active_scene].objs)	
	GObject.renderRectArray(self.scenes[self.active_scene].objs)
end

function GSceneManager:update(dt)
	if self.active_scene == 0 then
		return
	end
	GObject:updateArray(self.scenes[self.active_scene].objs, dt) 
end

function GSceneManager:mousepressed(x, y, button)
	if self.active_scene == 0 then
		return
	end
	GObject.mousePressArray(self.scenes[self.active_scene].objs, x, y, button) 
end

function GSceneManager:mousereleased(x, y, button)
	if self.active_scene == 0 then
		return
	end
	GObject.mouseReleaseArray(self.scenes[self.active_scene].objs, x, y, button) 
end

function GSceneManager:create_scene(name)
	local new_scene = GScene.create(name)
	self.scenes[name] = new_scene
	self.cur_add_scene = name
end
--[[function GSceneManager:addObjToScene(scene_name, obj)
	 self.scenes[scene_name]:add(obj)
end
function GSceneManager:addObj(obj)
	 self:addObjToScene(self.cur_add_scene, obj)
end]]

function GSceneManager:objOnShow()
	for i=1,#self.scenes[self.active_scene].objs do
		self.scenes[self.active_scene].objs[i]:onShow()
	end
end

function GSceneManager:activeScene(name)
	 self.last_scene = self.active_scene 
	 self.active_scene = name	 
	 self:objOnShow()
end

function GSceneManager:back()
	local buf = self.active_scene
	self.active_scene = self.last_scene
	self.last_scene = buf
	self:objOnShow()
end

function GSceneManager:addObjToScene(scene_name, gobj)
	 if gobj==nil then
	 	return
	 end
	 gobj:addToSceneManager(self.scenes[scene_name].objs) 
end

function GSceneManager:addObj(gobj)
	 self:addObjToScene(self.cur_add_scene, gobj)	 
end

function GSceneManager:printobjs(name)
	local objss = self.scenes[name].objs
	print(objss)
	for i=1,#objss do
		print(objss[i].name)
	end
end

function GSceneManager:showWin(name)
	win = winman:find(name)
	if win~=nil then
		win:init()
	end	
	self.back_scene = self.active_scene
	self.active_scene = name
end

function GSceneManager:closeWin()
	if self.back_scene ~= 0 then
		self.active_scene = self.back_scene
		self.back_scene = 0
	end
end

function GSceneManager:findByName(name, scene)
	if scene == nil then
		scene = self.active_scene
	end	
	for i=1,#self.scenes[scene].objs do
		--print(self.scenes[scene].objs[i].name)
		if self.scenes[scene].objs[i].name == name then
			return self.scenes[scene].objs[i]
		end
	end
	return nil
end

function GSceneManager:enableByName(name, enable, scene)
	local obj = self:findByName(name, scene)
	if obj~=nil then
		obj.enable = enable
	end
end

function GSceneManager:visibleByName(name, visible, scene)	
	local obj = self:findByName(name, scene)
	if obj~=nil then
		if visible then
			obj.visible = 1
			obj:onShow()
		else
			obj.visible = 0
		end
	end
end

function GSceneManager:setValueByName(name, value, scene)
	local obj = self:findByName(name, scene)
	if obj~=nil then
		obj.value = value
	end
end

function GSceneManager.quit()
	os.exit()
end