GVolume = {}

GVolume.value = 0
GVolume.prefix_str = ""
GVolume.post_str = ""
GVolume.maxvalue = 0
GVolume.minvalue = 0
GVolume.step = 1
GVolume.x = 0
GVolume.y = 0
GVolume.width = 0
GVolume.height = 0
GVolume.res_text = 0
GVolume.on_change_value = 0
GVolume.name = "GVolume"

function GVolume.create()
local _gvolume = {}
setmetatable(_gvolume, {__index = GVolume})
return _gvolume
end

function GVolume:getText()
	local prefix_str = self.prefix_str
	if type(self.prefix_str)=='table' then
		prefix_str = self.prefix_str:get()
	end
	return (prefix_str..self.value..self.post_str)
end

function GVolume:addToSceneManager(man_objs)
	local arr = {}
	
	local res_text = GObject.create("text")
	res_text.x = self.x
   	res_text.y = self.y
   	res_text.value = self:getText()
   	res_text.width = self.width
   	res_text.height = self.height
   	res_text.text_align = "center"
   	res_text.render_rect=true
   	res_text.color = GSkins.window_title_text
   	res_text.rect_color = GSkins.window_title_text   	
   	res_text.draw_cor_x = 5
   	res_text.gvolume = self        
   	res_text.on_update = GVolume.update_text
   	res_text.name = self.name..".".."res_text"
   	res_text.left_button_click = GVolume.text_on_click
   	
   	local line = GObject.create("rectangle")
	line.x=res_text.x
	line.y = res_text.y
	line.height=res_text.height
	line.width=0
	line.value="fill"
	line.color = GSkins.volume_line
	line.name = self.name..".".."line"
	
   	local slider = GObject.create("draw")
   	slider.x = -100	
	slider.left_button_click = 0
	slider.width = 15
	slider.height = 15 
	slider:loadButton("slider")
	slider.gvolume = self
	slider.on_update = GVolume.slider_set_pos
	slider.text = res_text
	slider.dragtype = 2	
	slider.on_drop_value = GVolume.set_value
	slider.line = line	
	slider.name = self.name..".".."slider"	
	
	res_text.slider = slider
	
	table.insert(man_objs, line)
	table.insert(man_objs, res_text)
	table.insert(man_objs, slider)
	
	table.insert(arr, line)
	table.insert(arr, res_text)
	table.insert(arr, slider)
	
	return arr
end

function GVolume.text_on_click(obj,x,y)
	obj.slider.bx=-100	
	GVolume.set_value(obj.slider,x-obj.slider.width/2)	
end
function GVolume.slider_set_pos(obj)
	if not obj.dragging.active then
		obj.x = obj.text.x+(obj.text.width*obj.gvolume.value/obj.gvolume.maxvalue)-obj.width/2
		obj.y = obj.text.y+obj.text.height
		obj.dragging.drag_min_x = obj.text.x-obj.width/2
	    obj.dragging.drag_max_x = obj.text.x+obj.text.width-obj.width/2
	    if obj.bx == -100 then
	    	obj.bx=obj.x
	    	obj.by=obj.y
	    end
	end
	obj.line.width=obj.text.width*obj.gvolume.value/obj.gvolume.maxvalue
end

function GVolume.update_text(obj)
	obj.value = obj.gvolume:getText()
end

function GVolume.set_value(obj,x)
	obj.gvolume.value = (x-obj.text.x+obj.width/2)*obj.gvolume.maxvalue/obj.text.width
	if obj.gvolume.on_change_value~=0 then
		obj.gvolume.on_change_value(obj.gvolume, obj.gvolume.value)
	end
end