-- 

GWindow = {}

GWindow.x=0
GWindow.y=0
GWindow.height=0
GWindow.width=0
GWindow.ok_event = 0
GWindow.cansel_event = 0
GWindow.dragging = {active = false, diffx = 0, diffy = 0}
GWindow.may_drag = true
GWindow.ok_button = 0
GWindow.cansel_button = 0
GWindow.close_button = 0
GWindow.win_objs = {}
GWindow.caption = 'Window caption'
GWindow.name = "GWindow"
GWindow.type = 'OK_CANSEL' 

function GWindow.create(type)
local _gwindow = {}
setmetatable(_gwindow, {__index = GWindow})
_gwindow.type = type
return _gwindow
end

function GWindow:addToSceneManager(man_objs)			
	local black = GObject.create("rectangle")
	black.x=self.x
	black.y=self.y
	black.bx = black.x
	black.by = black.y 
	black.height=self.height
	black.width=self.width
	black.value="fill"
	black.color = GSkins.window_title	
	black.rect_color = GSkins.window_rect
	black.render_rect = true
	black.alpha = 0
	black.end_alpha = 255
	black.name = self.name..".".."black"
	
	local body_margine = 10
	local body = GObject.create("rectangle")
	body.x=self.x+body_margine
	body.y=self.y+body_margine
	body.bx = body.x
	body.by = body.y 
	body.height=self.height-body_margine*2
	body.width=self.width-body_margine*2
	body.value="fill"
	body.color = GSkins.window_body
	body.name = self.name..".".."body"
	
	local shadow = GObject.create("rectangle")
	shadow.x=black.x+5
	shadow.y=black.y+5
	shadow.bx = shadow.x
	shadow.by = shadow.y
	shadow.height=black.height+5
	shadow.width=black.width+5
	shadow.value="fill"
	shadow.color = {0, 0, 0, 130}
	shadow.rect_color = {0, 0, 0, 130}	
	shadow.alpha = 0
	shadow.end_alpha = 130
	shadow.name = self.name..".".."shadow"
	
	local title_rect = GObject.create("rectangle")
	title_rect.x=black.x
	title_rect.y=black.y
	title_rect.bx = title_rect.x
	title_rect.by = title_rect.y
	title_rect.height=30
	title_rect.width=black.width
	title_rect.value="fill"
	title_rect.color = GSkins.window_title
	--title_rect.rect_color = {0, 255, 0, 255}	
	title_rect.alpha = 0
	title_rect.end_alpha = 255
	title_rect.left_button_click = GWindow.drag_window
	title_rect.left_button_release = GWindow.drop_window
	title_rect.name = self.name..".".."title_rect"
	self.title_rect = title_rect	
	
	local ok_button = GObject.create("draw")		
	ok_button.left_button_click = GWindow.click_ok 
	ok_button.on_custom_event = self.ok_event	
	ok_button:loadButton("OK")
	if( self.type == 'OK_CANSEL') then	
		ok_button.x = self.x+self.width - self.width/5
	else
		ok_button.x = self.x+self.width/2-ok_button.width/2
	end
	ok_button.y = self.y+self.height-3*ok_button.height/2
	ok_button.bx = ok_button.x
	ok_button.by = ok_button.y
	self.ok_button = ok_button;
	ok_button.name = self.name..".".."ok_button"
	
	local cansel_button = GObject.create("draw")	
	cansel_button.left_button_click = GWindow.click_cansel
	cansel_button.on_custom_event = self.cansel_event 
	cansel_button:loadButton("CANSEL")
	cansel_button.name = self.name..".".."cansel_button"
	self.cansel_button = cansel_button
	cansel_button.x = ok_button.x + cansel_button.width*2
	cansel_button.y = ok_button.y
	cansel_button.bx = cansel_button.x
	cansel_button.by = cansel_button.y
	if( self.type ~= 'OK_CANSEL') then	
		cansel_button.visible = 0
	end
	
	local cansel2_button = GObject.create("draw")
	cansel2_button.height = title_rect.height/3
	cansel2_button.width = cansel2_button.height 
	cansel2_button.x = self.x + self.width-body_margine-cansel2_button.height
	cansel2_button.y = self.y+body_margine
	cansel2_button.bx = cansel2_button.x
	cansel2_button.by = cansel2_button.y
	cansel2_button.left_button_click = GWindow.click_cansel
	cansel2_button.on_custom_event = self.cansel_event	
	cansel2_button:loadButton("x")	
	cansel2_button.name = self.name..".".."cansel2_button"
	self.close_button = cansel2_button
	
	local win_text = GObject.create("text")
	win_text.x = self.x
   	win_text.y = self.y
   	win_text.value = self.caption
   	win_text.width = self.width
   	win_text.height = love.graphics.getFont():getHeight()
   	win_text.text_align = "center"
   	win_text.color = GSkins.window_title_text
   	win_text.name = self.name..".".."win_text"
	
	table.insert(man_objs, shadow)
	table.insert(man_objs, black)
	table.insert(man_objs, body)
	table.insert(man_objs, title_rect)
	table.insert(man_objs, win_text)
	table.insert(man_objs, ok_button)
	table.insert(man_objs, cansel_button)
	table.insert(man_objs, cansel2_button)
	
	self:addToWin(shadow)
	self:addToWin(black)
	self:addToWin(body)
	self:addToWin(title_rect)
	self:addToWin(win_text)
	self:addToWin(ok_button)
	self:addToWin(cansel_button)
	self:addToWin(cansel2_button)
end

function GWindow:addToWin(obj)
	obj.parent = self
	obj.on_win_update = GWindow.update_show_win
	obj.bx = obj.x
	obj.by = obj.y
	table.insert(self.win_objs, obj)
end

function GWindow:addToWinArray(arr)
	for i=1,#arr do
		self:addToWin(arr[i])
	end
end

function GWindow:updateBXY()
	for i=1,#self.win_objs do
		self.win_objs[i].bx=self.win_objs[i].x
		self.win_objs[i].by=self.win_objs[i].y
	end
end

function GWindow:init()
	for i=1,#self.win_objs do
		if self.win_objs[i].on_init~=0 then
			self.win_objs[i].on_init(self.win_objs[i])
		end
	end
end

function GWindow:takeMySize(obj)
	self.x = obj.x
	self.y = obj.y
	self.height = obj.height
	self.width = obj.width
end

function GWindow.drag_window(obj,x,y)
	obj.parent.dragging.active = true
    obj.parent.dragging.diffx = x -- obj.parent.x
    obj.parent.dragging.diffy = y -- obj.parent.y
end

function GWindow.drop_window(obj,x,y)
	obj.parent.dragging.active = false
	obj.parent:updateBXY()
end

function GWindow.click_ok(obj)
	if obj.on_custom_event~=0 then
		obj.on_custom_event(obj)
	end
	Configuration.inst().manager:closeWin()
end

function GWindow.click_cansel(obj)
	obj.parent.dragging.active = false
	obj.parent:updateBXY()
	if obj.on_custom_event~=0 then
		obj.on_custom_event(obj)
	end	
	Configuration.inst().manager:closeWin()	
end

function GWindow.do_nothing()
	--  
end

function GWindow.update_show_win(obj,dt)
	--[[if obj.alpha < obj.end_alpha then
		obj.alpha = obj.alpha + dt*1000
		obj.color[4] = obj.alpha
		obj.rect_color[4] = obj.alpha
	end	]]		
	if obj.parent.dragging.active then
	  --[[if not obj.parent.title_rect:IsPointCollision(love.mouse.getX(), love.mouse.getY()) then
	  	obj.parent.dragging.active = false
   	  end]]
      obj.x = obj.bx + (love.mouse.getX() - obj.parent.dragging.diffx)
      obj.y = obj.by + (love.mouse.getY() - obj.parent.dragging.diffy)
   end   
end

function GWindow:setParent(obj)
	self.ok_button.parent = obj
	self.cansel_button.parent = obj
	self.close_button.parent = obj
end