function resetAllWhiteKeys()
	for i=1,#white_keys do
		white_keys[i].color = {255,255,255,255}
	end
end
--   note.  time  
function playNote(note, time)
	if (not note) or (not time) then
		return nil		
	end
	--   
	notes_list = {"do", "re", "mi", "fa", "sol", "la", "si"}
	
end
function colorEqu(color1, color2)
	return ((color1[1] == color2[1]) and (color1[2] == color2[2]) and (color1[3] == color2[3]) and (color1[4] == color2[4]))
end 

function setInfoClick(value)		
    Configuration.inst().info.click = value
end
function setMissClick(value)
	Configuration.inst().info.miss = value
end
function addInfoClick()
	Configuration.inst().info.click = Configuration.inst().info.click + 1
end
function addMissClick()
	Configuration.inst().info.miss = Configuration.inst().info.miss + 1
end
function endGame()
	resetAllWhiteKeys()
	sman:enableByName('go_button', true)
	sman:enableByName('tolist_button', true)
	sman:enableByName('goplay_button', true)
	sman:enableByName('stop_button', false)
	if Configuration.inst().play_type == 'go_button' then
		return
	end
	--   
	local notes_count = Configuration.inst().info.notes_count
	local notes_count_str = glang:getValue("Notes count: ")..notes_count
	local miss = Configuration.inst().info.miss
	local miss_str = glang:getValue("Notes miss: ")..miss
	local click = Configuration.inst().info.click
	local click_str = glang:getValue("Notes correct click: ")..click
	miss = miss + (notes_count-click)
	if( miss>notes_count ) then
		miss = notes_count
	end
	local res = ((notes_count-miss)/notes_count)*100 -- %
	res = math.ceil(res)
	local res_str = res..'%'
	
	sman:setValueByName('info_win.text1',notes_count_str,'after_info')
	sman:setValueByName('info_win.text2',click_str,'after_info')
	sman:setValueByName('info_win.text3',miss_str,'after_info')
	sman:setValueByName('info_win.text4',res_str,'after_info')	
	if res > Configuration.inst().songs_rate[Configuration.inst().songs_cur_item] then
		Configuration.inst().songs_rate[Configuration.inst().songs_cur_item] = res
	end
	showResultWin()
	Configuration.inst().play_type=nil
end
function markKey()
	local song_index = Configuration.inst().current_song_index
	local old_color = {10,10,10,10}
	local old_object = nil
	if song_index > 0 then
		obj = Configuration.inst().current_song[song_index]
		if obj ~=nil then
			old_color = obj.color 
			old_object = obj
			obj.color = {255,255,255,255}
			obj:resetTimer()
		end
	end
	song_index = song_index + 1 
	if song_index > #Configuration.inst().current_song then
		song_index = 1
		if Configuration.inst().play_type~=nil then
			endGame()
		end
		return nil
	end
	Configuration.inst().info.notes_count=Configuration.inst().info.notes_count+1
	obj = Configuration.inst().current_song[song_index]
	if obj ~=nil then
		local mark_color = Configuration.inst().mark_key_color1
		if (old_object == obj) and colorEqu(mark_color,old_color)  then
			mark_color = Configuration.inst().mark_key_color2			
		end
		obj.color = mark_color
		obj:setTimer(Configuration.inst().current_song_time[song_index], markKey)
	end
	Configuration.inst().current_song_index = song_index
	
	if Configuration.inst().play_type == 'go_button' then
		if obj.sound ~= 0 then
			love.audio.stop(obj.sound)
			love.audio.play(obj.sound)
		end	
	end
	
	return obj
end

--     
function hideTicker(obj)
	obj.visible = 0
	markKey()
end

--     index
function playSong(index)
	if not index then
		index = Configuration.inst().songs_cur_item
		if index == nil then
			index = 1
		end
	end 	
	if index > Configuration.inst().songs_count then
		return nil;
	end	
	Configuration.inst().current_song = {}
	Configuration.inst().current_song_time = {}
	Configuration.inst().current_song_index = 0
	setInfoClick(0)
	setMissClick(0)
	local ind = 1
	local rythm = Configuration.inst().songs.octave:children()[index]["@rhythm"]
	if glang.cur_lang==1 then
		song_title.value = Configuration.inst().songs.octave:children()[index]["@titleeng"]
	else 
		song_title.value = Configuration.inst().songs.octave:children()[index]["@title"]
	end
	local loop_count = #Configuration.inst().songs.octave:children()[index]:children()
	for i=1,loop_count do		
		local songs_count = #Configuration.inst().songs.octave:children()[index]:children()[i]:children()
		local repeat_count = Configuration.inst().songs.octave:children()[index]:children()[i]["@count"]
		for r=1,repeat_count do
			for j=1,songs_count do
				local note = Configuration.inst().songs.octave:children()[index]:children()[i]:children()[j]["@note"]
				local time = Configuration.inst().songs.octave:children()[index]:children()[i]:children()[j]["@time"]+0
				if time > 0 then
					time = 1/time
				end
				local time_r = time * rythm				
				Configuration.inst().current_song[ind] = GObject.findWithName(white_keys, note)
				Configuration.inst().current_song_time[ind] = time_r
				--playNote(note, time_r)
				ind = ind + 1
			end
		end
	end
	--markKey()
	if Configuration.inst().play_type == 'go_button' then
		markKey()
		return
	end
	local num_timer = sman:findByName('num_timer')
	if num_timer~=nil then
		num_timer.visible = 1
		num_timer:startAnimation(1, hideTicker)
	end
end