
function load_main()
--TODO:  ,      
   --     
   loadLang()
   loadSongsFromXml()   
   love.graphics.setFont(love.graphics.newFont("PTN57F.ttf", transformSize(20)))      
   load_gui()
   love.audio.setVolume(Configuration.inst().sound_volume)   
end
 

--  
function load_gui()
   sman = GSceneManager.create()
   winman = GWindowManager.create()
   --   
   sman:create_scene("piano")
      
   --    
   local key_white_width = Configuration.inst().screen_width/9
   local key_white_height = Configuration.inst().screen_height-2*key_white_width
   
   local key_black_width = key_white_width/3
   local key_black_height = key_white_height*2/3

   white_keys = {}
   black_keys = {}
   notes_list = {"do", "re", "mi", "fa", "sol", "la", "si"}
   for i=1,7 do
	   --   
	   local white_key = GObject.create("rectangle")
	   white_key.x=i*key_white_width
	   white_key.y=Configuration.inst().screen_height-key_white_height-key_white_width
	   white_key.height=key_white_height
	   white_key.width=key_white_width
	   white_key.value="fill"
	   white_key.color = {255, 255, 255, 255}
	   white_key.rect_color = {0, 0, 0, 255}	   
	   white_key.sound = Configuration.inst().notes[notes_list[i]]
	   white_key.left_button_click = obj_play_sound
	   white_key.name = notes_list[i]
	   white_key.render_rect = true
	   if i == 8 then
	      white_key.visible = 0
	      white_key.x=7*key_white_width
	   end
	   white_keys[i]=white_key
	   sman:addObj(white_key)
	   --   
	   if i < 7 then
	   	   if i == 3 then
	   	      local black_key = GObject.create("none")
	   	      black_keys[i]=black_key
	   	   else
			   local black_key = GObject.create("rectangle")
			   black_key.x=white_key.x+key_white_width-(key_black_width/2)
			   black_key.y=white_key.y
			   black_key.height=key_black_height
			   black_key.width=key_black_width
			   black_key.value="fill"
			   black_key.color = {0, 0, 0, 255}
			   black_key.name='black_key'
			   -- black_key.rect_color = {0, 0, 0, 255}	   	   
			   black_keys[i]=black_key			   
		   end
		end
   end 
   for i=1,7 do
      sman:addObj(black_keys[i])
   end

	love.graphics.setBackgroundColor(191,178,162)
--  
   song_title = GObject.create("text")
   song_title.x = key_white_width
   song_title.y = key_white_width/3
   song_title.value = ""
   song_title.width = Configuration.inst().screen_width - 2*key_white_width
   song_title.text_align = "center"
   song_title.name = "song_title"
   sman:addObj(song_title)      
   --  
   local num_timer = GObject.create("draw")
   num_timer:loadAnimation("num_",3, 1)   
   num_timer.x = Configuration.inst().screen_width/2-num_timer.width/2
   num_timer.y = Configuration.inst().screen_height/2-num_timer.height/2
   num_timer.name = "num_timer"
   num_timer.visible = 0
   sman:addObj(num_timer)
   
   --   
   local tolist_button = GObject.create("draw")
   tolist_button.x = 10
   tolist_button.y = 10
   tolist_button:loadButton('list')
   tolist_button.left_button_click = change_scene_to_track_list
   tolist_button.name = "tolist_button"
   tolist_button.click_sound = Configuration.inst().main_click_mp3
   sman:addObj(tolist_button)
   
   local play_buttons = GHorLayout.create(0, (Configuration.inst().screen_height - key_white_width/1.5) )
   --  GO
   local go_button = GObject.create("draw")
   go_button:loadButton('play-button')
   go_button.left_button_click = go_button_go
   go_button.name = "go_button"
   --sman:addObj(go_button)
   play_buttons:add(go_button)
   
   local stop_button = GObject.create("draw")
   stop_button:loadButton("stop")
   stop_button.left_button_click = stop_button_stop   
   stop_button.name = "stop_button"
   stop_button.enable = false
   --sman:addObj(stop_button)
   play_buttons:add(stop_button)
	
	--  
	local goplay_button = GObject.create("draw")    
    goplay_button:loadButton("play")
    goplay_button.left_button_click = go_button_go   
    goplay_button.name = "goplay_button"
    --sman:addObj(goplay_button)	
    play_buttons:add(goplay_button)
    
    play_buttons:centerByX(Configuration.inst().screen_width/2)
    sman:addObj(play_buttons)
	
	--  
	sman:create_scene("track_list")
	
	local fon_height = 0
	for i=2,20 do
		local list_fon = GObject.create("draw")
		list_fon.x = key_white_width-key_white_width/2		
		list_fon.value = love.graphics.newImage("fon.png")
		list_fon.y = list_fon.value:getHeight()*(i-1)
		list_fon.width = key_white_width*8
		list_fon.height = list_fon.value:getHeight()
		fon_height = list_fon.value:getHeight()
		
		sman:addObj(list_fon)
		
		if list_fon.y > Configuration.inst().screen_height then			
			break
		end
	end
	   
	local list_fon = GObject.create("draw")
	list_fon.x = key_white_width-key_white_width/2		
	list_fon.value = love.graphics.newImage("fon.png")
	list_fon.y = 0
	list_fon.width = key_white_width*8
	list_fon.height = list_fon.value:getHeight()
	fon_height = list_fon.value:getHeight()			
		
	local title_fon = GObject.create("draw")
	title_fon.x = key_white_width-key_white_width/2
	title_fon:loadDraw('title')		
	title_fon.y = 0
	title_fon.width = key_white_width*8
	title_fon.height = title_fon.value:getHeight()
	
	local song_list = GList.create()
	song_list.x_margin = key_white_width;
	song_list.y = 5+fon_height
	song_list.item_height = 39
	song_list.item_space = song_list.item_height/2
	song_list.width = Configuration.inst().screen_width - 1.5*key_white_width
	song_list.click_sound = Configuration.inst().main_click_mp3
	song_list.color = GSkins.window_title_text
	song_list.rect_color = GSkins.window_title_text
	
	loadTrackList(song_list)
	sman:addObj(song_list)
	sman:addObj(list_fon)
	sman:addObj(title_fon)
	
	-- 
	local ego = GObject.create("text")
	ego.value = glang:get('Author: Karachevtsev yu.yu. / come to facebook.com/Octave or vk.com/OctaveGame')
	ego.font = love.graphics.newFont("PTN57F.ttf", transformSize(14))
   	ego.height = ego.font:getHeight()
	ego.y = Configuration.inst().screen_height-ego.height
	ego.x = 0
	ego.width = Configuration.inst().screen_width-key_white_width
	ego.color = GSkins.window_title_text
	ego.text_align = "right"
	sman:addObj(ego)
	--  
	local options_button = GObject.create("draw") 			
	options_button.left_button_click = e_option_left_click 
	options_button:loadButton("options")
	options_button.x = Configuration.inst().screen_width-options_button.width-options_button.width/4
	options_button.y = 2*options_button.height
	options_button.click_sound = Configuration.inst().main_click_mp3
	sman:addObj(options_button)
	
	local exit_button = GObject.create("draw")
	exit_button.x = options_button.x 
	exit_button.y = options_button.y - options_button.height-10
	exit_button.left_button_click = GSceneManager.quit
	exit_button:loadButton("exit")
	exit_button.name = "exit_button"
	exit_button.width = options_button.width
	exit_button.height = options_button.height
	if ( not Configuration.inst().screen_windowed ) then
		exit_button.visible = 1
	else
		exit_button.visible = 1
	end
	 
	sman:addObj(exit_button)
	
	sman:create_scene("options")
	opt = GConf.create()
	opt.x=key_white_width
	opt.y=key_white_width
	opt.height=Configuration.inst().screen_height-key_white_width*2
	opt.width=Configuration.inst().screen_width-key_white_width*2
	sman:addObj(opt)
	
	sman:create_scene("after_info")
	local info_win = GWindow.create('OK')
   	--info_win.ok_event = GConf.save
   	--info_win.cansel_event=GWindow.do_nothing
   	info_win:takeMySize(opt)   	
   	info_win.name = "after_info"
   	info_win.caption = glang:get('Result')   	
	
	local info_win_text1 = GObject.create("text")
	info_win_text1.x = info_win.x + key_white_width
   	info_win_text1.y = info_win.y + key_white_width/2
   	info_win_text1.value = "VALUE"   	
   	info_win_text1.width = info_win.width-key_white_width
   	info_win_text1.height = love.graphics.getFont():getHeight()   	
   	info_win_text1.color = GSkins.window_title_text
   	info_win_text1.name = "info_win.text1"
   	--info_win_text1.text_align = "center"	
   	
   	local info_win_text2 = deepcopy(info_win_text1)
   	info_win_text2.y = info_win_text2.y + info_win_text2.height
   	info_win_text2.name = "info_win.text2"
   	
   	local info_win_text3 = deepcopy(info_win_text2)
   	info_win_text3.y = info_win_text3.y + info_win_text3.height
   	info_win_text3.name = "info_win.text3"
   	
   	local info_win_text4 = deepcopy(info_win_text3)
   	info_win_text4.x = info_win.x
   	info_win_text4.width = info_win.width
   	info_win_text4.text_align = "center"
   	info_win_text4.font = love.graphics.newFont("PTN57F.ttf", transformSize(80))
   	info_win_text4.height = info_win_text4.font:getHeight()
   	info_win_text4.y = info_win_text4.y + info_win_text4.height
   	info_win_text4.name = "info_win.text4"
	
	info_win:addToWin(info_win_text1)
	info_win:addToWin(info_win_text2)
	info_win:addToWin(info_win_text3)
	info_win:addToWin(info_win_text4)
		
	winman:add(info_win)
	sman:addObj(info_win)	
	sman:addObj(info_win_text1)
	sman:addObj(info_win_text2)
	sman:addObj(info_win_text3)
	sman:addObj(info_win_text4)
	      
    sman:activeScene("track_list")
    
    Configuration.inst().manager = sman
    if Configuration.inst().first_launch then
    	sman:showWin('options')
    end    
end

--  -  
function loadNotes()
	Configuration.inst().notes = {}
	Configuration.inst().notes["do"] = love.audio.newSource("do.mp3", "static")
	Configuration.inst().notes["re"] = love.audio.newSource("re.mp3", "static")
	Configuration.inst().notes["mi"] = love.audio.newSource("mi.mp3", "static")
	Configuration.inst().notes["fa"] = love.audio.newSource("fa.mp3", "static")
	Configuration.inst().notes["sol"] = love.audio.newSource("sol.mp3", "static")
	Configuration.inst().notes["la"] = love.audio.newSource("la.mp3", "static")
	Configuration.inst().notes["si"] = love.audio.newSource("si.mp3", "static")
	Configuration.inst().main_click_mp3 =  love.audio.newSource("click.mp3", "static")
end

--     xml 
function loadSongsFromXml()
	local xml = require("xmlSimple").newParser()
	Configuration.inst().songs = xml:loadFile("songs.xml", nil)
	Configuration.inst().songs_count = #Configuration.inst().songs.octave:children()
	Configuration.inst().songs_rate = {}	
	local rate_xml = loadSaveFile('stat.xml')
	for i=1,Configuration.inst().songs_count do
		local rate = 0
		if rate_xml~=nil and #rate_xml.stat:children()>=i then
			rate = tonumber(rate_xml.stat:children()[i]['@rate'])
		end
		table.insert(Configuration.inst().songs_rate, rate)
	end
	loadNotes()
end

function loadTrackList(song_list)
	for i=1,Configuration.inst().songs_count do
		local title = Configuration.inst().songs.octave:children()[i]["@title"]
		local title_eng = Configuration.inst().songs.octave:children()[i]["@titleeng"]
		local r = Configuration.inst().songs.octave:children()[i]["@rhythm"]
		local title_word = GWord.create({title_eng,title})
		song_list:Add(title_word)
	end
end